/*rec_bot6.c: should send a message to each beacon in order to PING
Then calculate and display the values
NEW NEW NEW  positioning-calculations*/

#include <unistd.h>
#include <conio.h>
#include <dmotor.h>
#include <dsensor.h>
#include <string.h>
#include <lnp.h>
#include <lnp-logical.h>

#define aa .0710843   /*linear function to transform raw_1 to real half-byte*/
#define bb -6.9802983 
#define cycle  4.3904  /*=1.28E-4 * 343 * 100 result in cm*/

int LOW_read,HIGH_read;

#define POINTS  3
#define SOLUTIONS 2

int x[POINTS]={0,92,0}; /*make these variables global*/
int y[POINTS]={0,75,150}; /*beacon-positions in cm*/
int d[POINTS]={0,0,0};
int i,j,k,m,n,diff,max;
double B,u;

int receive()
{
    int idx,wdt,err;
    long int SUM;

  /*initialize main variables*/
  LOW_read=0;
  HIGH_read=0;
  err=0;   /*no error*/
  wdt=0;  /*watch-dog-timer*/
  /*communication-protocole*/
  
  while(SENSOR_1>16000) /*wait until start-message*/
    {
       wdt+=1;
        if (wdt>3000) { err=+1; break; }
    }
  if(err==0) /*continue if no error*/
  {
    wdt=0;  
    while(SENSOR_1<16001) /*wait until low_byte*/
     {
        wdt+=1;
        if (wdt>1000) { err=+2; break; }
    }
  } 
  /*while waiting until pause-message compute average*/ 
  if(err==0) /*continue if no error*/
 {
     SUM=0;
     idx=0;  
    while(SENSOR_1>16000)  /*wait until high_byte*/
       {
          SUM+=SENSOR_1;
          idx+=1;
          if(idx>1000) { err=+3; break; }
       }
    
     LOW_read=SUM/64/idx; /*gives normal RCX raw-values 0..1023*/
  }

  if(err==0) /*continue if no error*/ 
  {
     wdt=0;  
     while(SENSOR_1<16001) 
      {
         wdt+=1;
         if (wdt>1000) { err=+4; break; }
      }
  } 
  /*while waiting until stop-message compute average*/ 

 if(err==0) /*continue if no error*/
 {
    SUM=0;
    idx=0;  
    while(SENSOR_1>16000)
     {
        SUM+=SENSOR_1;
        idx+=1;
        if(idx>1000) { err=+5; break; }
     }
    
   HIGH_read=SUM/64/idx; /*gives normal RCX raw-values 0..1023*/
  }


 if(err==0) /*continue if no error*/
 {
  wdt=0;  
  while(SENSOR_1<16001)  /*wait until NO_SIGNAL condition*/
     {
        wdt+=1;
        if (wdt>1000) { err=+6; break; }
     }
 } 
 return err;
}


int distance(int L, int H)
{
  double raw_1,dist;
  int LOW,HIGH,result;
 /*convert raw sensor-values to half-byte values*/
  raw_1=100000/L;
  raw_1=aa*raw_1+bb;
  LOW=raw_1;
  raw_1=100000/H;
  raw_1=aa*raw_1+bb;
  HIGH=raw_1; 

  /*calculate the distance*/
  dist=cycle*(16*HIGH+LOW)+.5;
  result=dist;      /*double to integer*/
  return(dist);
}

/*++++++++++++++++++++++++++++++++++++++++++++++++*/

#define p 0.0001  /*needed in sqrt-function*/

double abs(double x)  /*abs value-function*/
{
     if(x>0) {return x;} else { return -x;}
}


double sqr(double x)  /*square-function*/
{
  return x*x;
}


double sqrt(double x)   /*square-root-function*/
{                       /*Heron's algorithm*/
   double q,y;
   q=0;
   y=2;
   while(abs(y-q)>p)
   {
        q=x/y;
        y=(y+q)/2;
   }
   return y;
}

int pos()
{
  double xr[SOLUTIONS];
  double yr[SOLUTIONS];
  int temp1,err;
  double A,v,w,sq_d,delta; 
   
    err=0;  /*no error yet*/

   

   /*now the calculations*/
   A=((sqr(d[n])-sqr(d[m])+sqr(x[m])-sqr(x[n]))/diff+y[m]+y[n])/2;
   
   v=2*(y[n]*B-x[n]-A*B);
   w=-sqr(d[n])+sqr(x[n])+sqr(y[n])+sqr(A)-2*y[n]*A;
   delta=-4*u*w+sqr(v);
   if(delta<0) {err=7; } else
   {
		sq_d=sqrt(delta);
		xr[0]=(sq_d-v)/u/2;
		xr[1]=-(v+sq_d)/u/2;
		yr[0]=A-B*xr[0];
		yr[1]=A-B*xr[1];

		temp1=xr[0];
		cputs("xr0");
		sleep(1);
		lcd_int(temp1);
		sleep(1);

		temp1=yr[0];
		cputs("yr0");
		sleep(1);
		lcd_int(temp1);
		sleep(1);

		temp1=xr[1];
		cputs("xr1");
		sleep(1);
		lcd_int(temp1);
		sleep(1);
 
		temp1=yr[1];
		cputs("yr1");
		sleep(1);
		lcd_int(temp1);
		sleep(1);   
	}
 return err;
}




/*++++++++++++++++++++++++++++++++++++++++++++++++++*/



/**/

int main(int argc, char *argv[])
{
  int L1,L2,L3,H1,H2,H3,E1,E2,E3;
  char *s="X";

  /*positioning computing initialization*/
   max=0;
    for( i=0;i<2;i++)   /*find the two beacons which maximize the y[i]-y[j]*/
   {
        for(j=i+1;j<3;j++)
        {
              diff=abs(y[i]-y[j]);
              if(diff>max)
              {
                    max=diff;
                    m=i;
                    n=j;
                    k=3-i-j;  
               }
         }
   }
     
   diff=y[m]-y[n];
   B=(x[m]-x[n])/diff;
   u=1+sqr(B);

  /*end positioning  initialization*/


  lnp_logical_range(1); /*set long range*/

  /*start the IR / ultrasonic receiver*/
  motor_a_dir(fwd);
  motor_a_speed(MAX_SPEED);
  cputs("wait");
  sleep(6);
 
  while(1)  /*repeat forever*/
  {
  
	s[0]='A';   
	lnp_integrity_write(s,strlen(s));  /*command beacon A to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E1=receive(); /*get the error message*/
	L1=LOW_read;  /*get the byte*/
	H1=HIGH_read;
  
	msleep(25);  /*recover-time*/
  
	s[0]='B';
	lnp_integrity_write(s,strlen(s));  /*command beacon B to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E2=receive(); /*get the error message*/
	L2=LOW_read;  /*get the byte*/
	H2=HIGH_read; 
  
	msleep(25);  /*recover-time*/
 
	s[0]='C';
	lnp_integrity_write(s,strlen(s));  /*command beacon C to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E3=receive(); /*get the error message*/
	L3=LOW_read;  /*get the byte*/
	H3=HIGH_read;
  
	lcd_int(E1);
	sleep(1);
	lcd_int(distance(L1,H1));
	sleep(1);

	lcd_int(E2);
	sleep(1);
	lcd_int(distance(L2,H2));
	sleep(1);

	lcd_int(E3);
	sleep(1);
	lcd_int(distance(L3,H3));
	sleep(1);
 
	d[0]=distance(L1,H1);
	d[1]=distance(L2,H2);
	d[2]=distance(L3,H3);
    if(E1+E2+E3==0)	pos();  /*if there is no error, position the robot*/
  }
  return 0; /*to get rid of compiler warning*/
}


