/*rec_bot7bis.c: should send a message to each beacon in order to PING
Then calculate and display the values plus the positioning-calculations
NEW NEW NEW NEW sends the P-message to the beacons and the coordinates
NEW NEW NEW NEW multi-thread: new pilot-task and positioning-task
+ some corrections*/

#include <unistd.h>
#include <conio.h>
#include <dmotor.h>
#include <dsensor.h>
#include <string.h>
#include <lnp.h>
#include <lnp-logical.h>


pid_t position_thread;
pid_t pilot_thread;


/*++++++++++++++++++begin receive routines+++++++++++++*/

#define aa .0710843   /*linear function to transform raw_1 to real half-byte*/
#define bb -6.9802983 
#define cycle  4.3904  /*=1.28E-4 * 343 * 100 result in cm*/

int LOW_read,HIGH_read;

int receive()
{
    int idx,wdt,err;
    long int SUM;

  /*initialize main variables*/
  LOW_read=0;
  HIGH_read=0;
  err=0;   /*no error*/
  wdt=0;  /*watch-dog-timer*/
  /*communication-protocole*/
  
  while(SENSOR_1>16000) /*wait until start-message*/
    {
       wdt+=1;
        if (wdt>3000) { err=+1; break; }
    }
  if(err==0) /*continue if no error*/
  {
    wdt=0;  
    while(SENSOR_1<16001) /*wait until low_byte*/
     {
        wdt+=1;
        if (wdt>1000) { err=+2; break; }
    }
  } 
  /*while waiting until pause-message compute average*/ 
  if(err==0) /*continue if no error*/
 {
     SUM=0;
     idx=0;  
    while(SENSOR_1>16000)  /*wait until high_byte*/
       {
          SUM+=SENSOR_1;
          idx+=1;
          if(idx>1000) { err=+3; break; }
       }
    
     LOW_read=SUM/64/idx; /*gives normal RCX raw-values 0..1023*/
  }

  if(err==0) /*continue if no error*/ 
  {
     wdt=0;  
     while(SENSOR_1<16001) 
      {
         wdt+=1;
         if (wdt>1000) { err=+4; break; }
      }
  } 
  /*while waiting until stop-message compute average*/ 

 if(err==0) /*continue if no error*/
 {
    SUM=0;
    idx=0;  
    while(SENSOR_1>16000)
     {
        SUM+=SENSOR_1;
        idx+=1;
        if(idx>1000) { err=+5; break; }
     }
    
   HIGH_read=SUM/64/idx; /*gives normal RCX raw-values 0..1023*/
  }


 if(err==0) /*continue if no error*/
 {
  wdt=0;  
  while(SENSOR_1<16001)  /*wait until NO_SIGNAL condition*/
     {
        wdt+=1;
        if (wdt>1000) { err=+6; break; }
     }
 } 
 return err;
}


int distance(int L, int H)
{
  double raw_1,dist;
  int LOW,HIGH,result;
 /*convert raw sensor-values to half-byte values*/
  raw_1=100000/L;
  raw_1=aa*raw_1+bb;
  LOW=raw_1;
  raw_1=100000/H;
  raw_1=aa*raw_1+bb;
  HIGH=raw_1; 

  /*calculate the distance*/
  dist=cycle*(16*HIGH+LOW)+.5;
  result=dist;      /*double to integer*/
  return(dist);
}

/*++++++++++++++++end receive routines+++++++++++++++*/



/*++++++++++++++begin positioning routines++++++++++++*/



double abs(double x)  /*abs value-function*/
{
     if(x>0) {return x;} else { return -x;}
}


double sqr(double x)  /*square-function*/
{
  return x*x;
}


double sqrt(double x)   /*square-root-function*/
{                       /*Heron's algorithm*/
	int idx;
   double q,y;
   q=0;
   y=2;
   for(idx=0;idx<14;idx++)  /*enough precision and prevent 
							program from getting lost in loop*/
   {
        q=x/y;
        y=(y+q)/2;
   }
   return y;
}


#define POINTS  3
#define SOLUTIONS 2
#define TOLERANCE 2500 /*this is the square of the maximum distance of 
                          the two-circle intersection solution point to the 
                          third circle*/

int x[POINTS]={0,92,0}; /*make these variables global<===============beacon coordinates==============*/
int y[POINTS]={0,75,150}; /*beacon-positions in cm*/
int d[POINTS]={0,0,0};
int i,j,k,m,n,diff,max;
double B,u;
double xr[SOLUTIONS];
double yr[SOLUTIONS];


int pos()
{
  
  int temp1,err;
  double A,v,w,sq_d,delta,temp2,t1,t2; 
   
    err=0;  /*no error yet*/

   

   /*now the calculations*/
   A=((sqr(d[n])-sqr(d[m])+sqr(x[m])-sqr(x[n]))/diff+y[m]+y[n])/2;
   
   v=2*(y[n]*B-x[n]-A*B);
   w=-sqr(d[n])+sqr(x[n])+sqr(y[n])+sqr(A)-2*y[n]*A;
   delta=-4*u*w+sqr(v);
   if(delta<0) {err=7; } else
   {
		sq_d=sqrt(delta);
		xr[0]=(sq_d-v)/u/2;
		xr[1]=-(v+sq_d)/u/2;
		yr[0]=A-B*xr[0];
		yr[1]=A-B*xr[1];

		temp1=xr[0];
		cputs("xr0");
		sleep(1);
		lcd_int(temp1);
		sleep(1);

		temp1=yr[0];
		cputs("yr0");
		sleep(1);
		lcd_int(temp1);
		sleep(1);

		temp1=xr[1];
		cputs("xr1");
		sleep(1);
		lcd_int(temp1);
		sleep(1);
 
		temp1=yr[1];
		cputs("yr1");
		sleep(1);
		lcd_int(temp1);
		sleep(1);
	
		t1=abs(sqr(x[k]-xr[0])+sqr(y[k]-yr[0])-sqr(d[k])); /*test the third circle*/
        t2=abs(sqr(x[k]-xr[1])+sqr(y[k]-yr[1])-sqr(d[k]));

		if (t2<t1) 
		{
			/*exchange the solution, index0 will point the true solution*/
            			temp2=xr[0];
			xr[0]=xr[1];
			xr[1]=temp2;

			temp2=yr[0];
			yr[0]=yr[1];
			yr[1]=temp2;

           			 temp2=t2;
			t2=t1;
			t1=temp2;
                                                
		}
		if (t1>TOLERANCE)  err=8;
                   	                               
	}
 return err;
}

void P_message()
{
	char *st="Pms";
	int x,y;
	x=xr[0]/6;  /*this precision is enough for the beacons to fix the robot*/
	 if (x>127) x=127;  /*value still signed */
	 if (x<-128) x=-128;
	x+=128; /*to make an unsigned char*/
	y=yr[0]/6;
     if (y>127) y=127;
	 if (y<-128) y=-128;
	y+=128;
	st[1]=x;
	st[2]=y;
    lnp_integrity_write(st,strlen(st));  /*send generally P-message*/
	msleep(40); /*wait PIC error-condition to recover*/
}


/*++++++++++++++++++End Positioning routines++++++++++*/


/*+++++++++++++++Begin Positioning task+++++++++++++++*/

int position()
{
  int L1,L2,L3,H1,H2,H3,E1,E2,E3,error;
  char *s="X";

  
/*positioning initialization*/
   max=0;
    for( i=0;i<2;i++)   /*find the two beacons which maximize the y[i]-y[j]*/
   {
        for(j=i+1;j<3;j++)
        {
              diff=abs(y[i]-y[j]);
              if(diff>max)
              {
                    max=diff;
                    m=i;
                    n=j;
                    k=3-i-j;  
               }
         }
   }
     
   diff=y[m]-y[n];
   B=(x[m]-x[n])/diff;
   u=1+sqr(B);

  /*end positioning  initialization*/

while(1)  /*repeat forever*/
  {
  
	s[0]='A';   
	lnp_integrity_write(s,strlen(s));  /*command beacon A to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E1=receive(); /*get the error message*/
	L1=LOW_read;  /*get the byte*/
	H1=HIGH_read;
  
	msleep(25);  /*recover-time*/
  
	s[0]='B';
	lnp_integrity_write(s,strlen(s));  /*command beacon B to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E2=receive(); /*get the error message*/
	L2=LOW_read;  /*get the byte*/
	H2=HIGH_read; 
  
	msleep(25);  /*recover-time*/
 
	s[0]='C';
	lnp_integrity_write(s,strlen(s));  /*command beacon C to ping*/
	msleep(40);   /*wait until PIC no more in error-condition*/
	E3=receive(); /*get the error message*/
	L3=LOW_read;  /*get the byte*/
	H3=HIGH_read;
  
	lcd_int(E1);
	sleep(1);
	lcd_int(distance(L1,H1));
	sleep(1);

	lcd_int(E2);
	sleep(1);
	lcd_int(distance(L2,H2));
	sleep(1);

	lcd_int(E3);
	sleep(1);
	lcd_int(distance(L3,H3));
	sleep(1);
 
	d[0]=distance(L1,H1);
	d[1]=distance(L2,H2);
	d[2]=distance(L3,H3);
    if(E1+E2+E3==0)	/*if there is no error, position the robot*/
		{
		error=pos();
		if (error==0) { P_message(); } 
		else
			{
				cputs("err");
				sleep(1);
				lcd_int(error);
				sleep(1);
			}
		}
  }

  return 0; /*to get rid of the compiler messages*/
}


/*++++++++++++++++End Positioning task++++++++++++++++*/



/*+++++++++++++++Begin Pilot routines+++++++++++++++++*/


/*++++++++++++++++End Pilot routines++++++++++++++++++*/


/*+++++++++++++++Begin Pilot task++++++++++++++++++++++*/
int pilot()
{
	/*do nothing yet but loop*/
	while(1) msleep(10);
                
	return 0;
}

/*++++++++++++++++End Pilot task+++++++++++++++++++++++*/


/*MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN*/

int main(int argc, char *argv[])
{
  

  lnp_logical_range(1); /*set long range*/

  /*start the IR / ultrasonic receiver*/
  motor_a_dir(fwd);
  motor_a_speed(MAX_SPEED);
  cputs("wait");
  sleep(6);
  position_thread=execi(&position,0,0,PRIO_NORMAL+5,DEFAULT_STACK_SIZE);
  pilot_thread=execi(&pilot,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);
  
  return 0; /*to get rid of compiler warning*/
}


